diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -5777,9 +1757,9 @@ region_model::add_any_constraints_from_gassign (enum tree_code op,
 
 void
 region_model::add_any_constraints_from_gcall (enum tree_code op,
-					      tree rhs,
-					      const gcall *call,
-					      region_model_context *ctxt)
+					       tree rhs,
+					       const gcall *call,
+					       region_model_context *ctxt)
 {
   if (gimple_call_builtin_p (call, BUILT_IN_EXPECT)
       || gimple_call_builtin_p (call, BUILT_IN_EXPECT_WITH_PROBABILITY)
@@ -5796,192 +1776,221 @@ region_model::add_any_constraints_from_gcall (enum tree_code op,
 
 tristate
 region_model::eval_condition (tree lhs,
-			      enum tree_code op,
-			      tree rhs,
-			      region_model_context *ctxt)
+			       enum tree_code op,
+			       tree rhs,
+			       region_model_context *ctxt)
 {
   /* For now, make no attempt to model constraints on floating-point
      values.  */
   if (FLOAT_TYPE_P (TREE_TYPE (lhs)) || FLOAT_TYPE_P (TREE_TYPE (rhs)))
     return tristate::unknown ();
 
-  return eval_condition (get_rvalue (lhs, ctxt), op, get_rvalue (rhs, ctxt));
+  return eval_condition (get_rvalue (lhs, ctxt),
+			 op,
+			 get_rvalue (rhs, ctxt));
 }
 
-/* If SID is a constant value, return the underlying tree constant.
-   Otherwise, return NULL_TREE.  */
+/* Attempt to return a path_var that represents SVAL, or return NULL_TREE.
+   Use VISITED to prevent infinite mutual recursion with the overload for
+   regions.  */
 
-tree
-region_model::maybe_get_constant (svalue_id sid) const
+path_var
+region_model::get_representative_path_var (const svalue *sval,
+					    svalue_set *visited) const
 {
-  gcc_assert (!sid.null_p ());
-  svalue *sval = get_svalue (sid);
-  return sval->maybe_get_constant ();
-}
+  if (sval == NULL)
+    return path_var (NULL_TREE, 0);
 
-/* Create a new child region of the heap (creating the heap region if
-   necessary).
-   Return the region_id of the new child region.  */
+  if (const svalue *cast_sval = sval->maybe_undo_cast ())
+    sval = cast_sval;
 
-region_id
-region_model::add_new_malloc_region ()
-{
-  region_id heap_rid
-    = get_root_region ()->ensure_heap_region (this);
-  return add_region (new symbolic_region (heap_rid, NULL_TREE, true));
-}
+  /* Prevent infinite recursion.  */
+  if (visited->contains (sval))
+    return path_var (NULL_TREE, 0);
+  visited->add (sval);
 
-/* Attempt to return a tree that represents SID, or return NULL_TREE.  */
-
-tree
-region_model::get_representative_tree (svalue_id sid) const
-{
-  if (sid.null_p ())
-    return NULL_TREE;
+  auto_vec<path_var> pvs;
+  m_store.get_representative_path_vars (this, visited, sval, &pvs);
 
-  /* Find the first region that stores the value (e.g. a local) and
-     generate a representative tree for it.  */
-  unsigned i;
-  region *region;
-  FOR_EACH_VEC_ELT (m_regions, i, region)
-    if (sid == region->get_value_direct ())
-      {
-	path_var pv = get_representative_path_var (region_id::from_int (i));
-	if (pv.m_tree)
-	  return pv.m_tree;
-      }
+  if (tree cst = sval->maybe_get_constant ())
+    pvs.safe_push (path_var (cst, 0));
 
   /* Handle string literals and various other pointers.  */
-  svalue *sval = get_svalue (sid);
-  if (region_svalue *ptr_sval = sval->dyn_cast_region_svalue ())
+  if (const region_svalue *ptr_sval = sval->dyn_cast_region_svalue ())
+    {
+      const region *reg = ptr_sval->get_pointee ();
+      if (path_var pv = get_representative_path_var (reg, visited))
+	return path_var (build1 (ADDR_EXPR,
+				 TREE_TYPE (sval->get_type ()),
+				 pv.m_tree),
+			 pv.m_stack_depth);
+    }
+
+  /* If we have a sub_svalue, look for ways to represent the parent.  */
+  if (const sub_svalue *sub_sval = sval->dyn_cast_sub_svalue ())
     {
-      region_id rid = ptr_sval->get_pointee ();
-      path_var pv = get_representative_path_var (rid);
-      if (pv.m_tree)
-	return build1 (ADDR_EXPR,
-		       TREE_TYPE (sval->get_type ()),
-		       pv.m_tree);
+      const svalue *parent_sval = sub_sval->get_parent ();
+      const region *subreg = sub_sval->get_subregion ();
+      if (path_var parent_pv
+	    = get_representative_path_var (parent_sval, visited))
+	if (const field_region *field_reg = subreg->dyn_cast_field_region ())
+	  return path_var (build3 (COMPONENT_REF,
+				   sval->get_type (),
+				   parent_pv.m_tree,
+				   field_reg->get_field (),
+				   NULL_TREE),
+			   parent_pv.m_stack_depth);
     }
 
-  return maybe_get_constant (sid);
+  if (pvs.length () < 1)
+    return path_var (NULL_TREE, 0);
+
+  pvs.qsort (readability_comparator);
+  return pvs[0];
+}
+
+/* Attempt to return a tree that represents SVAL, or return NULL_TREE.  */
+
+tree
+region_model::get_representative_tree (const svalue *sval) const
+{
+  svalue_set visited;
+  return get_representative_path_var (sval, &visited).m_tree;
 }
 
-/* Attempt to return a path_var that represents the region, or return
+/* Attempt to return a path_var that represents REG, or return
    the NULL path_var.
    For example, a region for a field of a local would be a path_var
-   wrapping a COMPONENT_REF.  */
+   wrapping a COMPONENT_REF.
+   Use VISITED to prevent infinite mutual recursion with the overload for
+   svalues.  */
 
 path_var
-region_model::get_representative_path_var (region_id rid) const
+region_model::get_representative_path_var (const region *reg,
+					    svalue_set *visited) const
 {
-  region *reg = get_region (rid);
-  region *parent_reg = get_region (reg->get_parent ());
-  region_id stack_rid = get_stack_region_id ();
-  if (!stack_rid.null_p ())
-    if (parent_reg && parent_reg->get_parent () == stack_rid)
-      {
-	frame_region *parent_frame = (frame_region *)parent_reg;
-	tree t = parent_frame->get_tree_for_child_region (rid);
-	return path_var (t, parent_frame->get_depth ());
-    }
-  if (reg->get_parent () == get_globals_region_id ())
+  switch (reg->get_kind ())
     {
-      map_region *globals = get_root_region ()->get_globals_region (this);
-      if (globals)
-	return path_var (globals->get_tree_for_child_region (rid), -1);
-    }
-
-  /* Handle e.g. fields of a local by recursing.  */
-  region_id parent_rid = reg->get_parent ();
-  if (parent_reg)
-    {
-      if (reg->is_view_p ())
-	{
-	  path_var parent_pv = get_representative_path_var (parent_rid);
-	  if (parent_pv.m_tree && reg->get_type ())
-	    return path_var (build1 (NOP_EXPR,
-				     reg->get_type (),
-				     parent_pv.m_tree),
-			     parent_pv.m_stack_depth);
-	}
-
-      if (parent_reg->get_kind () == RK_STRUCT)
-	{
-	  map_region *parent_map_region = (map_region *)parent_reg;
-	  /* This can fail if we have a view, rather than a field.  */
-	  if (tree child_key
-		= parent_map_region->get_tree_for_child_region (rid))
-	    {
-	      path_var parent_pv = get_representative_path_var (parent_rid);
-	      if (parent_pv.m_tree && TREE_CODE (child_key) == FIELD_DECL)
-		return path_var (build3 (COMPONENT_REF,
-					 TREE_TYPE (child_key),
-					 parent_pv.m_tree, child_key,
-					 NULL_TREE),
-				 parent_pv.m_stack_depth);
-	    }
-	}
+    default:
+      gcc_unreachable ();
 
-      /* Handle elements within an array.  */
-      if (array_region *array_reg = parent_reg->dyn_cast_array_region ())
-      {
-	array_region::key_t key;
-	if (array_reg->get_key_for_child_region (rid, &key))
-	  {
-	    path_var parent_pv = get_representative_path_var (parent_rid);
-	    if (parent_pv.m_tree && reg->get_type ())
-	      {
-		tree index = array_reg->constant_from_key (key);
-		return path_var (build4 (ARRAY_REF,
-					 reg->get_type (),
-					 parent_pv.m_tree, index,
-					 NULL_TREE, NULL_TREE),
-				 parent_pv.m_stack_depth);
-	      }
-	  }
-      }
-    }
+    case RK_FRAME:
+    case RK_GLOBALS:
+    case RK_CODE:
+    case RK_HEAP:
+    case RK_STACK:
+    case RK_ROOT:
+       /* Regions that represent memory spaces are not expressible as trees.  */
+      return path_var (NULL_TREE, 0);
 
-  /* Handle string literals.  */
-  svalue_id sid = reg->get_value_direct ();
-  if (svalue *sval = get_svalue (sid))
-    if (tree cst = sval->maybe_get_constant ())
-      if (TREE_CODE (cst) == STRING_CST)
-	return path_var (cst, 0);
+    case RK_FUNCTION:
+      {
+	const function_region *function_reg
+	  = as_a <const function_region *> (reg);
+	return path_var (function_reg->get_fndecl (), 0);
+      }
+    case RK_LABEL:
+      gcc_unreachable (); // TODO
 
-  return path_var (NULL_TREE, 0);
-}
+    case RK_SYMBOLIC:
+      {
+	const symbolic_region *symbolic_reg
+	  = as_a <const symbolic_region *> (reg);
+	const svalue *pointer = symbolic_reg->get_pointer ();
+	path_var pointer_pv = get_representative_path_var (pointer, visited);
+	if (!pointer_pv)
+	  return path_var (NULL_TREE, 0);
+	tree offset = build_int_cst (pointer->get_type (), 0);
+	return path_var (build2 (MEM_REF,
+				 reg->get_type (),
+				 pointer_pv.m_tree,
+				 offset),
+			 pointer_pv.m_stack_depth);
+      }
+    case RK_DECL:
+      {
+	const decl_region *decl_reg = as_a <const decl_region *> (reg);
+	return path_var (decl_reg->get_decl (), decl_reg->get_stack_depth ());
+      }
+    case RK_FIELD:
+      {
+	const field_region *field_reg = as_a <const field_region *> (reg);
+	path_var parent_pv
+	  = get_representative_path_var (reg->get_parent_region (), visited);
+	if (!parent_pv)
+	  return path_var (NULL_TREE, 0);
+	return path_var (build3 (COMPONENT_REF,
+				 reg->get_type (),
+				 parent_pv.m_tree,
+				 field_reg->get_field (),
+				 NULL_TREE),
+			 parent_pv.m_stack_depth);
+      }
 
-/* Locate all regions that directly have value SID and append representative
-   path_var instances for them into *OUT.  */
+    case RK_ELEMENT:
+      {
+	const element_region *element_reg
+	  = as_a <const element_region *> (reg);
+	path_var parent_pv
+	  = get_representative_path_var (reg->get_parent_region (), visited);
+	if (!parent_pv)
+	  return path_var (NULL_TREE, 0);
+	path_var index_pv
+	  = get_representative_path_var (element_reg->get_index (), visited);
+	if (!index_pv)
+	  return path_var (NULL_TREE, 0);
+	return path_var (build4 (ARRAY_REF,
+				 reg->get_type (),
+				 parent_pv.m_tree, index_pv.m_tree,
+				 NULL_TREE, NULL_TREE),
+			 parent_pv.m_stack_depth);
+      }
 
-void
-region_model::get_path_vars_for_svalue (svalue_id sid, vec<path_var> *out) const
-{
-  unsigned i;
-  region *region;
-  FOR_EACH_VEC_ELT (m_regions, i, region)
-    if (sid == region->get_value_direct ())
+    case RK_OFFSET:
       {
-	path_var pv = get_representative_path_var (region_id::from_int (i));
-	if (pv.m_tree)
-	  out->safe_push (pv);
+	const offset_region *offset_reg
+	  = as_a <const offset_region *> (reg);
+	path_var parent_pv
+	  = get_representative_path_var (reg->get_parent_region (), visited);
+	if (!parent_pv)
+	  return path_var (NULL_TREE, 0);
+	path_var offset_pv
+	  = get_representative_path_var (offset_reg->get_byte_offset (),
+					 visited);
+	if (!offset_pv)
+	  return path_var (NULL_TREE, 0);
+	return path_var (build2 (MEM_REF,
+				 reg->get_type (),
+				 parent_pv.m_tree, offset_pv.m_tree),
+			 parent_pv.m_stack_depth);
       }
-}
 
-/* Set DST_RID value to be a new unknown value of type TYPE.  */
+    case RK_CAST:
+      {
+	path_var parent_pv
+	  = get_representative_path_var (reg->get_parent_region (), visited);
+	if (!parent_pv)
+	  return path_var (NULL_TREE, 0);
+	return path_var (build1 (NOP_EXPR,
+				 reg->get_type (),
+				 parent_pv.m_tree),
+			 parent_pv.m_stack_depth);
+      }
 
-svalue_id
-region_model::set_to_new_unknown_value (region_id dst_rid, tree type,
-					region_model_context *ctxt)
-{
-  gcc_assert (!dst_rid.null_p ());
-  svalue_id new_sid = add_svalue (new unknown_svalue (type));
-  set_value (dst_rid, new_sid, ctxt);
+    case RK_HEAP_ALLOCATED:
+    case RK_ALLOCA:
+      /* No good way to express heap-allocated/alloca regions as trees.  */
+      return path_var (NULL_TREE, 0);
 
-  // TODO: presumably purge all child regions too (but do this in set_value?)
+    case RK_STRING:
+      {
+	const string_region *string_reg = as_a <const string_region *> (reg);
+	return path_var (string_reg->get_string_cst (), 0);
+      }
 
-  return new_sid;
+    case RK_UNKNOWN:
+      return path_var (NULL_TREE, 0);
+    }
 }
 
 /* Update this model for any phis in SNODE, assuming we came from
@@ -6003,8 +2012,7 @@ region_model::update_for_phis (const supernode *snode,
       tree lhs = gimple_phi_result (phi);
 
       /* Update next_state based on phi.  */
-      bool is_back_edge = last_cfg_superedge->back_edge_p ();
-      handle_phi (phi, lhs, src, is_back_edge, ctxt);
+      handle_phi (phi, lhs, src, ctxt);
     }
 }
 
@@ -6029,8 +2037,8 @@ region_model::update_for_phis (const supernode *snode,
 
 bool
 region_model::maybe_update_for_edge (const superedge &edge,
-				     const gimple *last_stmt,
-				     region_model_context *ctxt)
+				      const gimple *last_stmt,
+				      region_model_context *ctxt)
 {
   /* Handle frame updates for interprocedural edges.  */
   switch (edge.m_kind)
@@ -6090,57 +2098,44 @@ region_model::maybe_update_for_edge (const superedge &edge,
 
 void
 region_model::update_for_call_superedge (const call_superedge &call_edge,
-					 region_model_context *ctxt)
+					  region_model_context *ctxt)
 {
-  /* Build a vec of argument svalue_id, using the current top
+  /* Build a vec of argument svalues, using the current top
      frame for resolving tree expressions.  */
   const gcall *call_stmt = call_edge.get_call_stmt ();
-  auto_vec<svalue_id> arg_sids (gimple_call_num_args (call_stmt));
+  auto_vec<const svalue *> arg_svals (gimple_call_num_args (call_stmt));
 
   for (unsigned i = 0; i < gimple_call_num_args (call_stmt); i++)
     {
       tree arg = gimple_call_arg (call_stmt, i);
-      arg_sids.quick_push (get_rvalue (arg, ctxt));
+      arg_svals.quick_push (get_rvalue (arg, ctxt));
     }
 
-  push_frame (call_edge.get_callee_function (), &arg_sids, ctxt);
+  push_frame (call_edge.get_callee_function (), &arg_svals, ctxt);
 }
 
 /* Pop the top-most frame_region from the stack, and copy the return
    region's values (if any) into the region for the lvalue of the LHS of
    the call (if any).  */
-
 void
 region_model::update_for_return_superedge (const return_superedge &return_edge,
-					   region_model_context *ctxt)
+					    region_model_context *ctxt)
 {
-  region_id stack_rid = get_stack_region_id ();
-  stack_region *stack = get_region <stack_region> (stack_rid);
-
   /* Get the region for the result of the call, within the caller frame.  */
-  region_id result_dst_rid;
+  const region *result_dst_reg = NULL;
   const gcall *call_stmt = return_edge.get_call_stmt ();
   tree lhs = gimple_call_lhs (call_stmt);
   if (lhs)
     {
       /* Normally we access the top-level frame, which is:
-	   path_var (expr, stack->get_num_frames () - 1)
+	   path_var (expr, get_stack_depth () - 1)
 	 whereas here we need the caller frame, hence "- 2" here.  */
-      gcc_assert (stack->get_num_frames () >= 2);
-      result_dst_rid = get_lvalue (path_var (lhs, stack->get_num_frames () - 2),
+      gcc_assert (get_stack_depth () >= 2);
+      result_dst_reg = get_lvalue (path_var (lhs, get_stack_depth () - 2),
 				   ctxt);
     }
 
-  purge_stats stats;
-  stack->pop_frame (this, result_dst_rid, true, &stats, ctxt);
-  // TODO: do something with the stats?
-
-  if (!lhs)
-    {
-      /* This could be a leak; try purging again, but this time,
-	 don't special-case the result sids (as was done in pop_frame).  */
-      purge_unused_svalues (&stats, ctxt);
-    }
+  pop_frame (result_dst_reg, NULL, ctxt);
 }
 
 /* Update this region_model with a summary of the effect of calling
@@ -6152,13 +2147,13 @@ region_model::update_for_return_superedge (const return_superedge &return_edge,
 
 void
 region_model::update_for_call_summary (const callgraph_superedge &cg_sedge,
-				       region_model_context *ctxt)
+					region_model_context *ctxt)
 {
   /* For now, set any return value to "unknown".  */
   const gcall *call_stmt = cg_sedge.get_call_stmt ();
   tree lhs = gimple_call_lhs (call_stmt);
   if (lhs)
-    set_to_new_unknown_value (get_lvalue (lhs, ctxt), TREE_TYPE (lhs), ctxt);
+    mark_region_as_unknown (get_lvalue (lhs, ctxt));
 
   // TODO: actually implement some kind of summary here
 }
@@ -6173,8 +2168,8 @@ region_model::update_for_call_summary (const callgraph_superedge &cg_sedge,
 
 bool
 region_model::apply_constraints_for_gcond (const cfg_superedge &sedge,
-					   const gcond *cond_stmt,
-					   region_model_context *ctxt)
+					    const gcond *cond_stmt,
+					    region_model_context *ctxt)
 {
   ::edge cfg_edge = sedge.get_cfg_edge ();
   gcc_assert (cfg_edge != NULL);
@@ -6198,8 +2193,8 @@ region_model::apply_constraints_for_gcond (const cfg_superedge &sedge,
 
 bool
 region_model::apply_constraints_for_gswitch (const switch_cfg_superedge &edge,
-					     const gswitch *switch_stmt,
-					     region_model_context *ctxt)
+					      const gswitch *switch_stmt,
+					      region_model_context *ctxt)
 {
   tree index  = gimple_switch_index (switch_stmt);
   tree case_label = edge.get_case_label ();
